function [t,x,V,V_U,B,N,TAF,AI,gamma,dens_vasc,r_V,TAF_dep_vasc]=sim_tumor_dynamics_MMAGS_4(flag_plot_details,protocol)

% a _2 modelleket hasznalja, amiben k_vol nem parameter hanem 1460/V_tot
cd 'c:\science\biology\angiogenic\discrete\complexity'

%clear all
clc
%global r_vasc_id c_g c_ev c_I c_deg c_n c_TAF q_TAF p_R
global par


x=[0.0388 % 0.036135547515031
   1.4353  % 1.440958373274309
   0.001158623286427 %0.001158623286427
   0.094054182228601  %0.094060523984571
  11.668966957135199 %11.669139338131130
   0.011376856122392 %0.011376856122392
   0.247297803788090 %0.247297803818217
   0.163260579737612]; %0.163260599621373];


% %=======================================
par.dens_vasc_id=x(1);    %0.05;
par.c_g=x(2);          %1.8;
par.c_ev=x(3);         %0.005;
par.c_n=x(4);          %0.103; % necrosis  % taken from complexity article
par.c_V=x(5);          %30; % vascularization
par.c_TAF=x(6);        %0.0005;
%c_TAF=0;
par.q_TAF=x(7);        %0.01; % clearence
par.c_h=x(8);          %0.1; % inhibition
%===================

par.ED_50=5*10^-5; % effective median dose % taken from complexity article

%q_AI=0.1825; % AI clearance parameters % taken from complexity article -
%elvileg az irodalombol ln 2/3.9=0.1777
%par.q_AI=x(9); % 
par.q_AI=0.5776;
par.K_AI=0.4409; % taken from complexity article





%======================  %reest by nlinfit ======
%par.dens_vasc_id=0.0465;
%par.c_g=2.2334;
%par.c_ev=7.6504e-04;
%par.c_n=0.1566595028358;
%par.c_V=2.743884591283987;
%par.c_TAF=0.0179; 
%par.q_TAF=0.0976;
%par.c_h=0.1222;
%par.q_AI=0.1777; % fixed as literature
%==================


%('error ref')
%MMAGS_2_obj_fncn(x)
%======================================

t0=0;
tfinal=21;
t_s=0.001;
tspan=[t0:t_s:tfinal];

V0=5;
%[t,y]=ode23s('tumor_dynamics_MMAGS_2',tspan,[V0 0 0 0 0 0]);

X0=[V0;0;0;0;0];
%========protocol 0 =====
if protocol==0

tfinal=19;
t_s=0.001;
tspan=[t0:t_s:tfinal];    
    
[t,x,V,N,B,TAF,AI,V_U,gamma,dens_vasc,r_V,TAF_dep_vasc]=simulate_MMAGS_ode_2(X0,protocol,tspan,t_s);

V_tot_final_NT_19=V(end)+N(end)
B_final_NT_19=B(end)

if flag_plot_details==1
    figure
    plot(t,V,'LineWidth',2)
    grid
    hold
    plot(t(1:end),V_U,'r:','LineWidth',2)
    plot(t,N,'m-.','LineWidth',2)
    plot(t,V+N,'k--','LineWidth',2)
    %plot(t2,y2(:,1),'r','LineWidth',2)
    %title('radius','Fontsize',14)
    legend('V','V_{u}','N','V_{tot}')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('volumes [mm^3]')

    figure
    plot(t(1:end),gamma,'LineWidth',2)
    grid
    legend('\gamma')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')

    figure
    plot(t(1:end),dens_vasc,'LineWidth',2)
    grid 
    hold
   % plot(t(1:end),dens_vasc_eff,'r--','LineWidth',2)
    plot(t(1:end),par.dens_vasc_id*ones(1,length(t(1:end))),'m-.','LineWidth',2)
    legend('[B]','[B]^{id}')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('')


    figure
    plot(t(1:end),r_V,'m-.','LineWidth',2)
    hold
    grid
    %plot(t(1:end),r_vasc_id*ones(1,length(t(1:end))),'r','LineWidth',2)
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    legend('r_v')
    ylabel('')

    figure
    plot(t,B,'LineWidth',2)
    legend('B')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('tumor vasculature volume [mm^3]')
end


adatsor_no_T=[104.8	181.7	338.3	484.0	870.9	1969.9	3312.9	5677.9	8029.2
              125.7	251.5	396.8	555.9	796.1	1212.8	1417.3	2045.4	2229.8
              76.0	112.3	186.1	383.1	807.9	1485.7	1960.8	3035.3	2780.6
              81.8	388.6	398.2	862.9	1405.9	3382.9	3689.0	6281.9	8641.7
              138.5	375.4	419.3	627.5	1111.6	2708.0	5224.7	10204.8	10734.4
              117.5	216.1	247.2	341.8	798.4	1810.3	2386.7	3790.3	5713.6
             %152.1	215.5	281.0	467.8	1106.0	2026.7	3256.7	4555.3	
             %98.6	523.9	787.0	1737.2	2543.7	4063.2			
              61.6	134.0	221.7	390.8	1303.7	2092.0	2528.8	6265.1	7232.3
              132.4	173.4	244.4	483.7	819.1	1375.4	1726.3	3475.0	4114.1
              82.1	105.4	156.7	360.8	656.6	1199.2	1284.2	2303.6	4472.0
              139.1	232.7	290.6	498.4	1119.5	1498.6	2526.8	4950.6	7516.9];

% dates=[   09. 02.	09. 05.	09. 07.	09. 09.	09. 12.	09. 14.	09. 16.	09. 19.
% 09. 21]
   t_sote_data= [3 5 7 9 11 13 15 17 19];

ref_no_T=mean(adatsor_no_T);
disp('final measured 19')
ref_no_T(end)

%[length(t) length(V) length(N)]

Sum_dev=0;
for i=1:length(t_sote_data)
    rel_t_index=find(t==t_sote_data(i));
    Sum_dev=Sum_dev+(ref_no_T(i)-(V(rel_t_index)+N(rel_t_index)))^2;
end

Sum_dev_normalized=Sum_dev/length(t_sote_data)
%return

figure
%plot(t,V_c,'LineWidth',2)
plot(t,V+N,'LineWidth',2)
grid
hold
plot(t_sote_data,adatsor_no_T(1,:),'b+')
plot(t_sote_data,adatsor_no_T(2,:),'b*')
plot(t_sote_data,adatsor_no_T(3,:),'bs')

plot(t_sote_data,adatsor_no_T(4,:),'bx')
plot(t_sote_data,adatsor_no_T(5,:),'bo')
plot(t_sote_data,adatsor_no_T(6,:),'bd')
plot(t_sote_data,adatsor_no_T(7,:),'bv')
plot(t_sote_data,adatsor_no_T(8,:),'b<')
plot(t_sote_data,adatsor_no_T(9,:),'b>')
plot(t_sote_data,adatsor_no_T(10,:),'bp')
plot(t_sote_data,ref_no_T,'b--')

legend('total simulated volume','Mouse A_1','Mouse A_2','Mouse A_3','Mouse A_4','Mouse A_5','Mouse A_6','Mouse A_7','Mouse A_8','Mouse A_9','Mouse A_{10}','average measured volume')
set(gca, 'FontUnits', 'points')
set(gca, 'FontSize', 14)
xlabel('time [days]')
ylabel('volumes [mm^3]')
axis([0 tfinal 0 max(1.5*(V+N))])

  
   
if flag_plot_details==1
    figure
    plot(t,TAF,'LineWidth',2)
    grid
    hold
    legend('T')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')

    figure
    plot(t,AI,'LineWidth',2)
    grid
    hold
    legend('I')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
end

tfinal=21;
t_s=0.001;
tspan=[t0:t_s:tfinal];    
    
[t_21,x_21,V_21,N_21,B_21,TAF_21,AI_21,V_U_21,gamma_21,dens_vasc_21,r_V_21,TAF_dep_vasc_21]=simulate_MMAGS_ode_2(X0,protocol,tspan,t_s);

V_tot_final_NT_21=V_21(end)+N_21(end)
%B_final_NT_21=B_21(end)

pause
close all

elseif protocol==1
%=========protocol 1====
%par

    [t,x,V,N,B,TAF,AI,V_U,gamma,dens_vasc,r_V,TAF_dep_vasc]=simulate_MMAGS_ode_2(X0,protocol,tspan,t_s);    

    V_tot_final_P1_21=V(end)+N(end)
    %B_final_P1_21=B(end)    
    
    t_ind_rel_19=find(t==19);
    V_tot_P1_19=V(t_ind_rel_19)+N(t_ind_rel_19)
    
    if flag_plot_details==1
        figure
        plot(t,V,'LineWidth',2)
        grid
        hold
        plot(t(1:end),V_U,'r--','LineWidth',2)
        plot(t,N,'m-.','LineWidth',2)
        %plot(t2,y2(:,1),'r','LineWidth',2)
        %title('radius','Fontsize',14)
        legend('V','V_{u}','N')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')
        ylabel('volumes [mm^3]')

        figure
        plot(t(1:end),gamma,'LineWidth',2)
        grid
        legend('\gamma')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')

        figure
        plot(t(1:end),dens_vasc,'LineWidth',2)
        grid 
        hold
        %plot(t(1:end),dens_vasc_eff,'r--','LineWidth',2)
        plot(t(1:end),par.dens_vasc_id*ones(1,length(t(1:end))),'m-.','LineWidth',2)
        legend('[B]','[B]^{id}')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')
        ylabel('')


        figure
        plot(t(1:end),r_V,'m-.','LineWidth',2)
        hold
        grid
        %plot(t(1:end),r_vasc_id*ones(1,length(t(1:end))),'r','LineWidth',2)
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')
        legend('r_v')
        ylabel('')

        figure
        plot(t,B,'LineWidth',2)
        legend('B')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')
        ylabel('tumor vasculature volume [mm^3]')
    end
    %return
    %=====================================================

    adatsor=[ 
    69.1
    51.9
    118.7
    0.0
    33.8
    66.1
    46.9
    101.6
    0.0
    21.9
    93.7
    93.5
    105.7
    0.0
    46.9
    118.7
    435.4
    158.3
    467.1
    68.9
    270.3
    1048.7
    447.8
    1594.4
    208.1
    347.2
    1846.5
    685.7
    2502.6
    324.6
    466.8
    2683.2
    1195.6
    5092.6
    763.3
    868.8
    4009.9
    1680.9
    6147.5
    1002.3
    1499.3
    5762.3
    2906.3
    10754.5
    1274.6
    2407.3
    9084.0
    3671.6
    15820.0
    2038.9];

    for i=1:10
        for j=1:5
            sote_data(j,i)=adatsor((i-1)*5+j);
        end
    end

    %sote_data

          %  return

    %t_sote_data= [1 3 5 7 9 11 13 15 17 19]; % az elso nap valojaban az oltas
    %utani 3.
    t_sote_data= [3 5 7 9 11 13 15 17 19 21];

    ref_1=mean(sote_data);
    disp('final measured day 21')
    ref_1(end)

    disp('measured day 19')
    ref_1(end-1)    
    
    %==============

    Sum_dev=0;
    for i=1:length(t_sote_data)
        rel_t_index=find(t==t_sote_data(i));
        Sum_dev=Sum_dev+(ref_1(i)-(V(rel_t_index)+N(rel_t_index)))^2;
    end

    Sum_dev_normalized=Sum_dev/length(t_sote_data)
    
    figure
    plot(t,V+N,'LineWidth',2)
    grid
    hold
    
    %

    plot(t_sote_data,sote_data(3,:),'b+')
    plot(t_sote_data,sote_data(4,:),'b*')
    plot(t_sote_data,sote_data(5,:),'bs')

    plot(t_sote_data,sote_data(2,:),'bx')
    plot(t_sote_data,sote_data(1,:),'bo')
    plot(t_sote_data,ref_1,'b--')
   
    legend('simulated V_{tot}','Mouse C_1','Mouse C_2','Mouse C_3','Mouse C_4','Mouse C_5','average measured volume')
    %legend('Mouse C_1','Mouse C_2','Mouse C_3','Mouse C_4','Mouse C_5','average volume')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 14)
    xlabel('time [days]')
    ylabel('volumes [mm^3]')
    axis([0 tfinal 0 max(1.3*adatsor)])

    if flag_plot_details==1
        figure
        plot(t,TAF,'LineWidth',2)
        grid
        hold
        legend('T')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')

        figure
        plot(t,AI,'LineWidth',2)
        grid
        hold
        legend('I')
        set(gca, 'FontUnits', 'points')
        set(gca, 'FontSize', 18)
        xlabel('time [days]')
    end
    pause
    close all
elseif protocol==2
%====================================================== protocol 2

adatsor_2 = [85.4;43.9;43.9;46.6;59.2;77.1;119.6;41.3;59.0;77.5;59.2;49.6;...
    49.6;62.7;73.4;148.4;46.8;59.2;114.2;52.8;65.9;77.5;73.7;94.2;174.5;66.2;...
    66.2;243.9;66.2;90.3;205.7;109.2;167.8;259.5;181.6;81.7;383.2;114.2;119.6;...
    501.0;160.5;596.9;544.2;269.3;108.9;603.5;148.4;243.9;1435.4;270.3;781.3;...
    588.5;471.7;195.8;859.1;244.3;397.7;2046.3;543.6;1085.3;793.3;1064.6;280.1;...
    1071.3;385.6;587.1;4521.3;1096.6;1630.7;1105.3;1435.4;544.2;1530.9;854.5;811.4;...
    6117.1;1861.3;2515.5;1966.8;1908.6;793.3;2531.8;1153.3;1066.6;11401.2;3915.8;...
    2882.8;2570.0;2677.4;1113.4];

    t_sote_data= [3 5 7 9 11 13 15 17 19 21];
 
 Eger1 = adatsor_2(1:9:end);

 Eger2 = adatsor_2(2:9:end);
 
 Eger3 = adatsor_2(3:9:end);
 Eger4 = adatsor_2(4:9:end);
 Eger5 = adatsor_2(5:9:end);
 Eger6 = adatsor_2(6:9:end);
 Eger7 = adatsor_2(7:9:end);
 Eger8 = adatsor_2(8:9:end);
 Eger9 = adatsor_2(9:9:end);

ref_2=mean([Eger1';Eger2';Eger3';Eger4';Eger5';Eger6';Eger7';Eger8';Eger9']);

    disp('final measured')
    ref_2(end)

    disp('measured day 19')
    ref_2(end-1)        
    
%====================================

[t,x,V,N,B,TAF,AI,V_U,gamma,dens_vasc,r_V,TAF_dep_vasc]=simulate_MMAGS_ode_2(X0,protocol,tspan,t_s);    

V_tot_final_P2=V(end)+N(end)
%B_final_P2=B(end)

    t_ind_rel_19=find(t==19);
    V_tot_P2_19=V(t_ind_rel_19)+N(t_ind_rel_19)

Sum_dev=0;
for i=1:length(t_sote_data)
    rel_t_index=find(t==t_sote_data(i));
    Sum_dev=Sum_dev+(ref_2(i)-(V(rel_t_index)+N(rel_t_index)))^2;
end

Sum_dev_normalized=Sum_dev/length(t_sote_data)

if flag_plot_details==1
    figure
    plot(t,V,'LineWidth',2)
    grid
    hold
    plot(t(1:end),V_U,'r:','LineWidth',2)
    plot(t,N,'m-.','LineWidth',2)
    plot(t,V+N,'k--','LineWidth',2)
    %plot(t2,y2(:,1),'r','LineWidth',2)
    %title('radius','Fontsize',14)
    legend('V','V_{u}','N','V_{tot}')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('volumes [mm^3]')

    figure
    plot(t(1:end),gamma,'LineWidth',2)
    grid
    legend('\gamma')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')

    figure
    plot(t(1:end),dens_vasc,'LineWidth',2)
    grid 
    hold
    %plot(t(1:end),dens_vasc_eff,'r--','LineWidth',2)
    plot(t(1:end),par.dens_vasc_id*ones(1,length(t(1:end))),'m-.','LineWidth',2)
    legend('[B]','[B]^{id}')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('')


    figure
    plot(t(1:end),r_V,'m-.','LineWidth',2)
    hold
    grid
    %plot(t(1:end),r_vasc_id*ones(1,length(t(1:end))),'r','LineWidth',2)
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    legend('r_V')
    ylabel('')

    figure
    plot(t,B,'LineWidth',2)
    legend('B')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
    ylabel('tumor vasculature volume [mm^3]')
end


figure
%plot(t,V_c,'LineWidth',2)
plot(t,V+N,'LineWidth',2)
grid
hold
%

plot(t_sote_data,Eger1,'b+')
plot(t_sote_data,Eger2,'b*')
plot(t_sote_data,Eger3,'bs')

plot(t_sote_data,Eger4,'bx')
plot(t_sote_data,Eger5,'bo')
plot(t_sote_data,Eger6,'bd')
plot(t_sote_data,Eger7,'bv')
plot(t_sote_data,Eger8,'b<')
plot(t_sote_data,Eger9,'b>')
plot(t_sote_data,ref_2,'b--')


%plot(t2,V_c2,'b--','LineWidth',2)
%plot(t2,V_p2,'r--','LineWidth',2)
%title('volumes','Fontsize',14)
%legend('core, no proliferation','periphery, no proliferation','core, proliferation','periphery, proliferation')
%legend('core','periphery','total','Mouse C_5','Mouse C_4','Mouse C_1','Mouse C_2','Mouse C_3')
legend('simulated V_{tot}','Mouse E_1','Mouse E_2','Mouse E_3','Mouse E_4','Mouse E_5','Mouse E_6','Mouse E_7','Mouse E_8','Mouse E_9','average volume')
%legend('Mouse E_1','Mouse E_2','Mouse E_3','Mouse E_4','Mouse E_5','Mouse E_6','Mouse E_7','Mouse E_8','Mouse E_9','average volume')
set(gca, 'FontUnits', 'points')
set(gca, 'FontSize', 14)
xlabel('time [days]')
ylabel('volumes [mm^3]')
axis([0 tfinal 0 max(1.3*adatsor_2)])

if flag_plot_details==1
    figure
    plot(t,TAF,'LineWidth',2)
    grid
    hold
    legend('T')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')

    figure
    plot(t,AI,'LineWidth',2)
    grid
    hold
    legend('I')
    set(gca, 'FontUnits', 'points')
    set(gca, 'FontSize', 18)
    xlabel('time [days]')
end
pause
close all

end
%=============================================================





%=============================================================

%pause
%close all

%return

%=======================================================


